// vim: set tw=80 ts=2 sw=2 sts=2 :

import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { HttpClientModule } from '@angular/common/http';

import { NgLoggerModule, Level } from '@nsalaun/ng-logger';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { ToastrModule } from 'ngx-toastr';
import { TextMaskModule } from 'angular2-text-mask';

import { BalanceChartComponent } from './balanceChart.component';
import { CategoryChartComponent } from './categoryChart.component';
import { OperationRowComponent } from './operationRow.component';
import { CategoryService } from './category.service';
import { OperationService } from './operation.service';
import { OperationListComponent } from './operationList.component';
import { OperationDeleteModalComponent } from './operationDeleteModal.component';
import { OperationFormComponent } from './operationForm.component';
import { OperationEditModalComponent } from './operationEditModal.component'

export function $modalServiceFactory(i: any) {
  return i.get('$modal');
}

export function accountIdServiceFactory(i: any) {
  return i.get('accountIdService');
}

@NgModule({
  imports: [
    HttpClientModule,
    CommonModule,
    FormsModule,
    NgLoggerModule,
    ToastrModule,
    NgbModule,
    TextMaskModule
  ],
  providers: [
    CategoryService,
    OperationService,
    {
      provide: 'accountIdService',
      deps: ['$injector'],
      useFactory: accountIdServiceFactory
    }
  ],
  declarations: [
    BalanceChartComponent,
    CategoryChartComponent,
    OperationRowComponent,
    OperationListComponent,
    OperationDeleteModalComponent,
    OperationFormComponent,
    OperationEditModalComponent,
  ],
  entryComponents: [
    BalanceChartComponent,
    CategoryChartComponent,
    OperationRowComponent,
    OperationListComponent,
    OperationDeleteModalComponent,
    OperationFormComponent,
    OperationEditModalComponent,
  ]
})
export class OperationModule {}
